'--EditorDemo.vbs - This script creates a simple text editor.
'-- a file can be opened in the large text box. text to find can be entered in
'--small text box. For this demo the Find button does double duty.
'--it will search for the given text except in 2 cases: If "B" is entered in small text box,
'--clicking Find will make the text bold. If "L" is entered, clicking Find will make the text large.
'--(normal text is 8 pt. large text is 10 pt.)
'-------------------------------------------------

Dim ob, fso, r, st1, st2, text1point
Set ob = CreateObject("JSForm.Window")
Set fso = CreateObject("Scripting.FileSystemObject")

ob.title = "A Simple Text Editor"
ob.showtextbox(true, 600, 200) = 2
ob.text2caption = "Enter text to find OR enter B to make text bold OR L to make text large."
ob.showbuttons = 3
ob.button1caption = "Open"
ob.button2caption = "Save"
ob.button3caption = "Find"
ob.Persist = true
 text1point = 1  '---------initialize variable for FindIt sub to keep track of search position.
 
   '--create a loop that will keep going until window is closed. The whole "program"
   '--is in this loop, with sub calls each time a button is clicked.

 Do  
     ob.show
     r = ob.Response(st1, st2)   '---------------get text1 text and text2 text.
        if r = 1 then                 '-----open was clicked.----------
           call OpenIt         
        elseif r = 2 then            '--save was clicked.--------------
          call SaveIt(st1)       
        elseif r = 3 then        '----------find was clicked.-----
          if st2 <> ""  and st1 <> "" then
             call FindIt(st1, st2)
          end if
        else
           wscript.quit
        end if
  Loop

'------------------------------------------------------------------------------------
Sub Openit()  '--sub to load file into Text1 when Open is clicked.----------
  dim f, s, ts
  f = ob.ChooseFileOpen
     if fso.FileExists(f) = true then
        set ts = fso.OpenTextFile(f, 1) 
           s = ts.readall
           ts.close
        set ts = nothing
       ob.text1text = s
   end if
End Sub
'------------------------------------------------------------------------------------

Sub SaveIt(s)  '--sub to save Text1 text when Save is clicked.--------------
  dim f, ts, bn, r1
    f = ob.ChooseFileSave
      if f <> "" then
            bn = fso.GetFileName(f)
                   if instr(1, bn, ".", 1) = 0 then
                        f = f & ".txt"
                   end if
         if fso.FileExists(f) = false then
            set ts = fso.CreateTextFile(f)
               ts.write s
               ts.close
            set ts = nothing
        else
          r1 = msgbox("That file exists. Overwrite it?", 36, "FileExists")
             if r1 = 7 then
                 exit sub
             else
                 set ts = fso.OpenTextFile(f, 2)
                 ts.write s
                 ts.close
                set ts = nothing
            end if
         end if
      end if
 End Sub
'----------------------------------------------------------------------

Sub FindIt(s, s1)  '----sub to highlight text in box when Find is clicked.
           '----search for text2 text in text1 text. if found, highlight it,
          '--change button caption to Find Next andset beginning of next search
          '--with text1point variable.
          '--if search text is B or L, adjust text properties accordingly.
  dim start, lentxt
 if s1 = "B" then
      ob.textfontbold = true
 elseif s1 = "L" then
      ob.textfontlarge = true
 else
    start = instr(text1point, s, s1, 1)
      if start <> 0 then
         lentxt = len(s1)
         ob.text1select start, lentxt
         text1point = start + lentxt
         ob.button3caption = "Find Next"
     Else
         msgbox "No match.", 0, "Find"
         ob.button3caption = "Find"
         text1point = 1
     end if 
 end if
End Sub

