'--PersistDemo.vbs demonstrates the Persist property. 
'--when Persist is set to True all properties set will remain so between
'--calls to Show. When set to false (the default) properties must be reset with each call to Show.
'--In this script the window layout stays the same while the button color changes so
'--there's no need to reset the window between Shows.

'---------------------------------------------------
Dim fso, ob, r, c
Set fso = CreateObject("Scripting.FileSystemObject")
set ob = CreateObject("JSForm.Window")

'----------first window setup. Persist is set to true, causing property settings to be
'-----------retained between window showings.

 ob.title = "Persist Demo"
 ob.caption = "This script demonstrates the use of the Persist property" & vbcrlf & " to control whether the window resets between shows." & vbcrlf & " As long as you click CHOOSE you can change the button color" & vbcrlf & " and keep the rest of the window the same." & vbcrlf & vbcrlf & "Also of note: This caption is coded with carriage returns." & vbcrlf & "The caption will resize to fit the longest line but will not wrap." & vbcrlf & "The use of vbCrLf must be planned accordingly."
 ob.showbuttons = 2
 ob.button1caption = "Choose"
 ob.button2caption = "Cancel"
 ob.WindowColor = "FFFFFF"
 ob.ButtonColor = "FFF8F9"
 ob.TextColor = "0000AA"
 ob.persist = true
 
'---with Persist set to true, a loop is set up to show the window, allow a color selection,
'---then reshow the window with the button color changed accordingly.
'--The loop will continue as long as CHOOSE is clicked.

   do until r = 2
      ob.show
     r = ob.response()
       if r = 1 then
          c = ob.ChooseColorHex
            If c <> "" then
               ob.ButtonColor = c
            end if
       else
             exit do
       end if
   loop

'---CANCEL was clicked. Set Persist to False and call Reset to clear the properties.

    ob.persist = false
    ob.reset
    ob.title = "RESET"
    ob.caption = "All properties have now been reset."
    ob.showbuttons = 1
    ob.button1caption = "OK"
    ob.show
   
 
 
